import { Level } from './level';
export declare class Logger<T> {
    private name;
    color: string;
    private developmentMode;
    private allowed;
    private isMuted;
    fixedWidth: number | undefined;
    private display?;
    constructor(name: string, color: string, developmentMode: boolean, allowed: Level[], isMuted: boolean, fixedWidth: number | undefined, display?: ((name: string, data: any, level: Level, moduleName: string) => void) | undefined);
    private _data;
    private _error;
    private _info;
    private _warn;
    /**
     * Logs message and data with the level=data
     * @param message The message
     * @param otherParams Additional parameters
     */
    data: (message: string, ...otherParams: any[]) => Logger<T>;
    /**
     * Logs message and data with the level=error
     * @param message The message
     * @param otherParams Additional parameters
     */
    error: (message: string, ...otherParams: any[]) => this;
    /**
     * Logs message and data with the level=info
     * @param message The message
     * @param otherParams Additional parameters
     */
    info: (message: string, ...otherParams: any[]) => this;
    /**
     * Logs message and data with the level=warn
     * @param message The message
     * @param otherParams Additional parameters
     */
    warn: (message: string, ...otherParams: any[]) => this;
    private _logMessage;
    private level;
    static isProductionMode: boolean;
    mute(): void;
}
